
TODO: TODO_96_01_13_29: multiple bootstrap stages to instantiate configs

# Problem

## Single high-level config source for multiple low-level configs

In multi-language environment (for `argrelay`, at least Bash and Python) config files often
contain identical information in different formats.

FS_85_33_46_53: bootstrap process should have at least three distinct stages:
*   minimal to set up Python venv with required dependencies
*   use high-level config input (some YAML) to instantiate all other configs
*   do anything else

## Minimizing initial Bash bootstrap

Current single `@/exe/bootstrap_env.bash` has to be self-sufficient - it cannot rely on any dependencies.

Because it is single, it keeps running with the same minimal assumptions about environment:
*   it has to continue running as Bash script
*   it (mostly) cannot source outside files as they should be upgraded first by this same boostrap script

With multiple bootstrap stages, next bootstrap stage can run in Python (easier to test) -
this is similar to the split of FS_36_17_84_44 `check_env` script.
